# -*- python -*-
# $RCSfile: mainthreadGUI.py,v $
# $Revision: 1.7 $
# $Author: langer $
# $Date: 2004/07/14 16:26:37 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Routines for running functions in the main thread.  These override
# the definitions in common/mainthread.py.  See comments there.

from common import debug
from common import mainthread
from common import thread_enable
from common.IO.GUI import oof_mainiteration
import Queue

callQueue = Queue.Queue(-1) ## A Queue with *infinite* size

def run_gui(func, args=(), kwargs={}):
    global callQueue
    callQueue.put( (func, args, kwargs) )
    if thread_enable.query():
        oof_mainiteration.oof_idle_add(main_execute)
    else:
        main_execute()

def main_execute():
    global callQueue
    (func, args, kwargs) = callQueue.get()
    func(*args, **kwargs)


def runBlock_gui(func, args=(), kwargs={}):
    ## debug.fmsg()
    if thread_enable.query() and not mainthread.mainthread():
        ## debug.fmsg("Calling oof_idle_block_add.")
        return oof_mainiteration.oof_idle_block_add(func, args, kwargs)
    else:
        ## debug.fmsg("Calling directly.")
        return func(*args, **kwargs)
    
# Override non-GUI thread_call, thread_call_block.
from common import mainthread
mainthread.run = run_gui
mainthread.runBlock = runBlock_gui
