# -*- python -*-
# $RCSfile: initialize.py,v $
# $Revision: 1.60 $
# $Author: langer $
# $Date: 2004/07/21 19:14:10 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# engine specific GUI initialization code

import engine.initialize

# Import widgets before GUI page definitions.
import engine.IO.GUI.cijklparamwidgets
import engine.IO.GUI.meshparamwidgets
import engine.IO.GUI.skeletongroupwidgets
import engine.IO.GUI.tensorwidgets
import engine.IO.GUI.materialswidget
import engine.IO.GUI.profilefunctionwidget
import engine.IO.GUI.invariantwidget
import engine.IO.GUI.strainwidget
import engine.IO.GUI.bdymodparamwidget

# Toolbox definitions
import engine.IO.GUI.skeletoninfoGUI
import engine.IO.GUI.meshinfoGUI
import engine.IO.GUI.movenodeGUI
import engine.IO.GUI.pinnodesGUI
import engine.IO.GUI.skeletonselectiontoolboxGUI
import engine.IO.GUI.skeletonbdyGUI
import engine.IO.GUI.meshcswidget
#import engine.IO.GUI.skeletonbdytoolboxGUI
import engine.IO.GUI.meshcstoolboxGUI
import engine.IO.GUI.pixelinfoGUI

# GUI page definitions.
import engine.IO.GUI.skeletonSelectionPage
import engine.IO.GUI.boundarycondPage
import engine.IO.GUI.skeletonBoundaryPage
import engine.IO.GUI.materialsPage
import engine.IO.GUI.skeletonPage
import engine.IO.GUI.meshPage
import engine.IO.GUI.fieldPage
import engine.IO.GUI.equationPage
import engine.IO.GUI.solverPage
import engine.IO.GUI.analyzePage
import engine.IO.GUI.boundaryAnalysisPage
