# -*- python -*-
# $RCSfile: tensorwidgets.py,v $
# $Revision: 1.13 $
# $Author: reida $
# $Date: 2004/08/24 14:55:15 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Contains size-specific descendants of SymmetricMatrixInput,
# which have as values objects of the SymmMatrix type
# from SWIG.engine.SymmMatrix.

from SWIG.engine import symmmatrix
from common import debug
from common.IO.GUI.matrixparamwidgets import SymmetricMatrixInput
from common.IO.GUI import parameterwidgets
from SWIG.engine import fieldindex

class SymmMatrix3Widget(SymmetricMatrixInput):
    def __init__(self, param, scope=None):
        debug.mainthreadTest()
        SymmetricMatrixInput.__init__(self,"",3,3,value=None,scope=scope)
        for i in symmmatrix.voigtIndices:
            self.floats[i].gtk.connect("activate", self.new_value, None)
            self.floats[i].gtk.connect("focus_out_event", self.new_value)
        self.set_values(param.value)
    def set_values(self, value):
        debug.mainthreadTest()
        self.value = value
        if value is not None:
            for i in symmmatrix.voigtIndices:
                self.floats[i].set_value(self.value.get(*i))

        self.gtk.show_all()
    def get_value(self):
        return self.value
    def new_value(self, gtk, event):
        result = symmmatrix.SymmMatrix3(*[self.floats[i].get_value()
                                          for i in symmmatrix.voigtIndices])
        self.set_values(result)

def _SymmMatrix3Parameter_makeWidget(self, scope=None):
    return SymmMatrix3Widget(self, scope)

symmmatrix.SymmMatrix3Parameter.makeWidget = _SymmMatrix3Parameter_makeWidget
                                        
            
