# -*- python -*-
# $RCSfile: solvermenu.py,v $
# $Revision: 1.62 $
# $Author: redwing $
# $Date: 2004/09/09 20:18:26 $


# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from SWIG.common import switchboard
from SWIG.common.IO import progressbar
from SWIG.engine import solver
from SWIG.engine import solverstepper
from SWIG.engine import preconditioner
from common import debug
from common import labeltree
from common import utils
from common import thread_enable
from common.IO import automatic
from common.IO import mainmenu
from common.IO import oofmenu
from common.IO import parameter
from common.IO import reporter
from common.IO import whoville
from engine import skeletoncontext
from types import *
import engine.mesh



try:
    from SWIG.engine.PETSc import petsc_solver
except ImportError:
    pass


solvermenu = mainmenu.OOF.addItem(oofmenu.OOFMenuItem('Solver', cli_only=1))

def _solve(menuitem, mesh, solver):
    debug.fmsg('solving')
    solverProgressBar = menuitem.getProgressBar("continuous")
    meshcontext = engine.mesh.meshes[mesh]
    meshcontext.reserve()
    meshcontext.solutiontimestamp.increment()
    try:
        ## meshcontext.getObject().equilibrate(method) ## old way of solving a mesh. Will break if a steppersolver is passed in
        solver.apply(meshcontext) ## solver applies itself
        
    finally:
        meshcontext.cancel_reservation()
    
solvermenu.addItem(
    oofmenu.OOFMenuItem('Solve',
                        callback=_solve,
                        threadable= oofmenu.THREADABLE,
                        params=[
    whoville.WhoParameter('mesh', engine.mesh.meshes),
##    parameter.Parameter('method', solver.SolverPtr)
    parameter.Parameter('solver', solverstepper.SolverDriver)
    ]))




