// -*- C++ -*-
// $RCSfile: matvec.h,v $
// $Revision: 1.6 $
// $Author: reida $
// $Date: 2003/09/23 18:19:55 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

// Definitions of the matrix and vector types to be used for
// *numerical* (as opposed to bookkeeping) calculations.

#ifndef MATVEC_H
#define MATVEC_H

#include "SparseLib++/vecdefs.h"

// double precision full matrix
// CAUTION if this matrix is not stored as a contiguous set of
// columns, then mvmult.C needs to be changed!
#include "SparseLib++/mvmd.h"
#define MATRIX_D MATRIX_double	/* see SparseLib/vecdefs.h */

// integer full matrix
#include "SparseLib++/mvmi.h"
#define MATRIX_I MATRIX_int	/* see SparseLib/vecdefs.h */

// double compressed row sparse matrix
#include "SparseLib++/comprow_double.h"
#define SPARSE_MATRIX_D CompRow_Mat_double

// double vector
#define VECTOR_D VECTOR_double	/* see SparseLib/vecdefs.h */

#endif
