# -*- python -*-
# $RCSfile: newimageGUI.py,v $
# $Revision: 1.4 $
# $Author: langer $
# $Date: 2004/06/10 22:00:46 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Buttons for creating Microstructures from Images appear on the
# Microstructure page, but have to be defined here in the image
# module.

from SWIG.common import switchboard
from SWIG.image import oofimage
from common import debug
from common import guitop
from common import microstructure
from common.IO import microstructuremenu
from common.IO.GUI import fileselector
from common.IO.GUI import microstructurePage
from common.IO.GUI import parameterwidgets
from image.IO import imagemenu  # ensures that OOFMenuItems have been created.
from gtk import *

def newMSfromImage(button):
    menuitem = microstructuremenu.micromenu.Create_From_Image
    if parameterwidgets.getParameters(title='Create Microstructure from Image',
                                      *menuitem.params):
        menuitem.callWithDefaults()

newfromimagebutton = GtkButton("New from Image")
newfromimagebutton.connect('clicked', newMSfromImage)
guitop.top().tooltip(newfromimagebutton,
                     "Create a new microstructure with an image that has been loaded already.")
newfromimagebutton.set_sensitive(0)


def sensitizeNewFromImageButton():
    newfromimagebutton.set_sensitive(oofimage.imageContexts.nActual() > 0)

microstructurePage.addNewButton(newfromimagebutton, sensitizeNewFromImageButton)

def newwhoCB(path):
    sensitizeNewFromImageButton()
    
switchboard.requestCallback(('new who', 'Image'), newwhoCB)
switchboard.requestCallback(('remove who', 'Image'), newwhoCB)

##############

def newMSfromImageFile(button):
    menuitem = microstructuremenu.micromenu.Create_From_ImageFile
    wparam = menuitem.get_arg('width')
    hparam = menuitem.get_arg('height')
    msparam = menuitem.get_arg('microstructure_name')
    file = fileselector.fileSelector(
        ident='Image/MS',
        title='Load Image and create Microstructure',
        params=(msparam, wparam, hparam))
    if file is not None:
        menuitem.callWithDefaults(filename=file)

newfromfilebutton = GtkButton("New from Image File")
newfromfilebutton.connect('clicked', newMSfromImageFile)
guitop.top().tooltip(newfromfilebutton,
                     "Create a new microstructure with a new image that is being loaded.")

microstructurePage.addNewButton(newfromfilebutton)

