// -*- C++ -*-
// $RCSfile: pixelselectioncourieri.h,v $
// $Revision: 1.1 $
// $Author: langer $
// $Date: 2004/04/21 14:44:31 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#ifndef PIXELSELECTIONCOURIERI_H
#define PIXELSELECTIONCOURIERI_H

#include "common/pixelselectioncourier.h"
class OOFImage;
class CColor;
class ColorDifference;
class BasicBurner;

// Color Difference 
class ColorSelection : public PixelSelectionCourier {
private:
  OOFImage *image;
  const CColor *color;
  const ColorDifference *diff;
  BoolArray selected;
  BoolArray::iterator sel_iter;
  void advance();
public:
  ColorSelection(const CMicrostructure *ms, OOFImage *immidge,
		 const CColor *color, const ColorDifference *diff);
  virtual ~ColorSelection();
  virtual void start();
  virtual ICoord currentPoint() const;
  virtual void next();
};

// Burn
class BurnSelection : public PixelSelectionCourier {
private:
  BasicBurner *burner;
  OOFImage *image;
  const ICoord spark;
  BoolArray selected;
  BoolArray::iterator sel_iter;
  void advance();
public:
  BurnSelection(const CMicrostructure *ms,
		BasicBurner *burner, OOFImage *immidge, const ICoord *pt);
  virtual ~BurnSelection() {}
  virtual void start();
  virtual ICoord currentPoint() const;
  virtual void next();
};

#endif // PIXELSELECTIONCOURIERI_H
